#
# DARK FRAMES auto-combining script for 8K-mosaic CCD camera attached to the UH88.
#
#      2008.12.09  --- Ver.0.0
#
# 0.0: Removing temporal files 

!rm -fr ___*.*

!echo "0: Temporal files were deleted."

#
# 1: Making data list files
#
# 1.1: Spliting raw-data list into those obtained with each CCD-chip. 
!ls -1 RAW/*.fits > ___raw.lst
!awk '{if(substr($1,16,1)==0){print $1}}' ___raw.lst > ___raw0.lst
!awk '{if(substr($1,16,1)==1){print $1}}' ___raw.lst > ___raw1.lst
!awk '{if(substr($1,16,1)==2){print $1}}' ___raw.lst > ___raw2.lst
!awk '{if(substr($1,16,1)==3){print $1}}' ___raw.lst > ___raw3.lst
!awk '{if(substr($1,16,1)==4){print $1}}' ___raw.lst > ___raw4.lst
!awk '{if(substr($1,16,1)==5){print $1}}' ___raw.lst > ___raw5.lst
!awk '{if(substr($1,16,1)==6){print $1}}' ___raw.lst > ___raw6.lst
!awk '{if(substr($1,16,1)==7){print $1}}' ___raw.lst > ___raw7.lst
#
# 1.2: Getting FITS HEADER INFORMATION
imhe @___raw0.lst l+ > ___raw0-1.lst
imhe @___raw1.lst l+ > ___raw1-1.lst
imhe @___raw2.lst l+ > ___raw2-1.lst
imhe @___raw3.lst l+ > ___raw3-1.lst
imhe @___raw4.lst l+ > ___raw4-1.lst
imhe @___raw5.lst l+ > ___raw5-1.lst
imhe @___raw6.lst l+ > ___raw6-1.lst
imhe @___raw7.lst l+ > ___raw7-1.lst
#
# 1.3: Getting header of "IMAGETYP"
!grep 'IMAGETYP' ___raw0-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw0-typ.lst
!grep 'IMAGETYP' ___raw1-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw1-typ.lst
!grep 'IMAGETYP' ___raw2-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw2-typ.lst
!grep 'IMAGETYP' ___raw3-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw3-typ.lst
!grep 'IMAGETYP' ___raw4-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw4-typ.lst
!grep 'IMAGETYP' ___raw5-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw5-typ.lst
!grep 'IMAGETYP' ___raw6-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw6-typ.lst
!grep 'IMAGETYP' ___raw7-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw7-typ.lst
#
# 1.4: Getting header of "EXPTIME"
!grep 'EXPTIME' ___raw0-1.lst | awk '{print $3}' > ___raw0-exp.lst
!grep 'EXPTIME' ___raw1-1.lst | awk '{print $3}' > ___raw1-exp.lst
!grep 'EXPTIME' ___raw2-1.lst | awk '{print $3}' > ___raw2-exp.lst
!grep 'EXPTIME' ___raw3-1.lst | awk '{print $3}' > ___raw3-exp.lst
!grep 'EXPTIME' ___raw4-1.lst | awk '{print $3}' > ___raw4-exp.lst
!grep 'EXPTIME' ___raw5-1.lst | awk '{print $3}' > ___raw5-exp.lst
!grep 'EXPTIME' ___raw6-1.lst | awk '{print $3}' > ___raw6-exp.lst
!grep 'EXPTIME' ___raw7-1.lst | awk '{print $3}' > ___raw7-exp.lst
#
# 1.5: Pasting file name, IMAGETYP, and EXPTIME
!paste ___raw0.lst ___raw0-typ.lst ___raw0-exp.lst > ___raw0-log.lst 
!paste ___raw1.lst ___raw1-typ.lst ___raw1-exp.lst > ___raw1-log.lst 
!paste ___raw2.lst ___raw2-typ.lst ___raw2-exp.lst > ___raw2-log.lst 
!paste ___raw3.lst ___raw3-typ.lst ___raw3-exp.lst > ___raw3-log.lst 
!paste ___raw4.lst ___raw4-typ.lst ___raw4-exp.lst > ___raw4-log.lst 
!paste ___raw5.lst ___raw5-typ.lst ___raw5-exp.lst > ___raw5-log.lst 
!paste ___raw6.lst ___raw6-typ.lst ___raw6-exp.lst > ___raw6-log.lst 
!paste ___raw7.lst ___raw7-typ.lst ___raw7-exp.lst > ___raw7-log.lst 

!echo "1: New temporal files were output."

#
# 2: Making combining dark images
#
# 2.1: Extracting dark images with EXPTIME=480s 
!awk '{if(($2=="DARK") && (substr($3,1,3)=="480")){print $1}}' ___raw0-log.lst > ___dark480-0.lst
!awk '{if(($2=="DARK") && (substr($3,1,3)=="480")){print $1}}' ___raw1-log.lst > ___dark480-1.lst
!awk '{if(($2=="DARK") && (substr($3,1,3)=="480")){print $1}}' ___raw2-log.lst > ___dark480-2.lst
!awk '{if(($2=="DARK") && (substr($3,1,3)=="480")){print $1}}' ___raw3-log.lst > ___dark480-3.lst
!awk '{if(($2=="DARK") && (substr($3,1,3)=="480")){print $1}}' ___raw4-log.lst > ___dark480-4.lst
!awk '{if(($2=="DARK") && (substr($3,1,3)=="480")){print $1}}' ___raw5-log.lst > ___dark480-5.lst
!awk '{if(($2=="DARK") && (substr($3,1,3)=="480")){print $1}}' ___raw6-log.lst > ___dark480-6.lst
!awk '{if(($2=="DARK") && (substr($3,1,3)=="480")){print $1}}' ___raw7-log.lst > ___dark480-7.lst
#
# 2.2: Combining dark images
imstat @___dark480-0.lst
imcombine @___dark480-0.lst DARK480-0.fits combine=average reject=avsigclip offsets=none

imstat @___dark480-1.lst
imcombine @___dark480-1.lst DARK480-1.fits combine=average reject=avsigclip offsets=none

imstat @___dark480-2.lst
imcombine @___dark480-2.lst DARK480-2.fits combine=average reject=avsigclip offsets=none

imstat @___dark480-3.lst
imcombine @___dark480-3.lst DARK480-3.fits combine=average reject=avsigclip offsets=none

imstat @___dark480-4.lst
imcombine @___dark480-4.lst DARK480-4.fits combine=average reject=avsigclip offsets=none

imstat @___dark480-5.lst
imcombine @___dark480-5.lst DARK480-5.fits combine=average reject=avsigclip offsets=none

imstat @___dark480-6.lst
imcombine @___dark480-6.lst DARK480-6.fits combine=average reject=avsigclip offsets=none

imstat @___dark480-7.lst
imcombine @___dark480-7.lst DARK480-7.fits combine=average reject=avsigclip offsets=none

!echo "2: Eight Dark files with EXPTIME=480s were finished."

#
# 3: Removing temporal files
#
del ___*.lst

!echo "3: Temporal files were removed."
!echo "Thank you !!"
#
# Shingo Nishiura
#   Post Doctral fellow at the KISO Observatory from 2001 to 2003
#   Assistant Research at Tokyo Gakugei University from 2003
#   e-mail: nishiura@u-gakugei.ac.jp
#


