#
# Dark subtraction and Flat fielding of I-band OBJECT FRAMES script for 8K-mosaic CCD camera attached to the UH88.
#
#      2008.12.11  --- Ver.0.0
#
# [USAGE] cl < objdsffI.cl
#
# 0.0: Removing temporal files 

!rm -fr ___*.*

!echo "0: Temporal files were deleted."

#
# 1: Making data list files
#
# 1.1: Spliting raw-data list into those obtained with each CCD-chip. 
!ls -1 RAW/*.fits > ___raw.lst
!awk '{if(substr($1,16,1)==0){print $1}}' ___raw.lst > ___raw0.lst
!awk '{if(substr($1,16,1)==1){print $1}}' ___raw.lst > ___raw1.lst
!awk '{if(substr($1,16,1)==2){print $1}}' ___raw.lst > ___raw2.lst
!awk '{if(substr($1,16,1)==3){print $1}}' ___raw.lst > ___raw3.lst
!awk '{if(substr($1,16,1)==4){print $1}}' ___raw.lst > ___raw4.lst
!awk '{if(substr($1,16,1)==5){print $1}}' ___raw.lst > ___raw5.lst
!awk '{if(substr($1,16,1)==6){print $1}}' ___raw.lst > ___raw6.lst
!awk '{if(substr($1,16,1)==7){print $1}}' ___raw.lst > ___raw7.lst
#
# 1.2: Getting FITS HEADER INFORMATION
imhe @___raw0.lst l+ > ___raw0-1.lst
imhe @___raw1.lst l+ > ___raw1-1.lst
imhe @___raw2.lst l+ > ___raw2-1.lst
imhe @___raw3.lst l+ > ___raw3-1.lst
imhe @___raw4.lst l+ > ___raw4-1.lst
imhe @___raw5.lst l+ > ___raw5-1.lst
imhe @___raw6.lst l+ > ___raw6-1.lst
imhe @___raw7.lst l+ > ___raw7-1.lst
#
# 1.3: Getting header of "IMAGETYP"
!grep 'IMAGETYP' ___raw0-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw0-typ.lst
!grep 'IMAGETYP' ___raw1-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw1-typ.lst
!grep 'IMAGETYP' ___raw2-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw2-typ.lst
!grep 'IMAGETYP' ___raw3-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw3-typ.lst
!grep 'IMAGETYP' ___raw4-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw4-typ.lst
!grep 'IMAGETYP' ___raw5-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw5-typ.lst
!grep 'IMAGETYP' ___raw6-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw6-typ.lst
!grep 'IMAGETYP' ___raw7-1.lst | awk '{if(substr($2,2,9)=="FLATFIELD"){print substr($2,2,9)}else{print substr($2,2)}}' > ___raw7-typ.lst
#
# 1.4: Getting header of "EXPTIME"
!grep 'EXPTIME' ___raw0-1.lst | awk '{print $3}' > ___raw0-exp.lst
!grep 'EXPTIME' ___raw1-1.lst | awk '{print $3}' > ___raw1-exp.lst
!grep 'EXPTIME' ___raw2-1.lst | awk '{print $3}' > ___raw2-exp.lst
!grep 'EXPTIME' ___raw3-1.lst | awk '{print $3}' > ___raw3-exp.lst
!grep 'EXPTIME' ___raw4-1.lst | awk '{print $3}' > ___raw4-exp.lst
!grep 'EXPTIME' ___raw5-1.lst | awk '{print $3}' > ___raw5-exp.lst
!grep 'EXPTIME' ___raw6-1.lst | awk '{print $3}' > ___raw6-exp.lst
!grep 'EXPTIME' ___raw7-1.lst | awk '{print $3}' > ___raw7-exp.lst
#
# 1.5: Pasting file name, IMAGETYP, and EXPTIME
!paste ___raw0.lst ___raw0-typ.lst ___raw0-exp.lst > ___raw0-log.lst 
!paste ___raw1.lst ___raw1-typ.lst ___raw1-exp.lst > ___raw1-log.lst 
!paste ___raw2.lst ___raw2-typ.lst ___raw2-exp.lst > ___raw2-log.lst 
!paste ___raw3.lst ___raw3-typ.lst ___raw3-exp.lst > ___raw3-log.lst 
!paste ___raw4.lst ___raw4-typ.lst ___raw4-exp.lst > ___raw4-log.lst 
!paste ___raw5.lst ___raw5-typ.lst ___raw5-exp.lst > ___raw5-log.lst 
!paste ___raw6.lst ___raw6-typ.lst ___raw6-exp.lst > ___raw6-log.lst 
!paste ___raw7.lst ___raw7-typ.lst ___raw7-exp.lst > ___raw7-log.lst 

!echo "1: New temporal files were output."

#
# 2: Making dark-subtracted object images
#
# 2.1: Extracting flat images 
!awk '{if($2=="OBJECT"){print $1}}' ___raw0-log.lst > ___obj-0.lst
!awk '{if($2=="OBJECT"){print $1}}' ___raw1-log.lst > ___obj-1.lst
!awk '{if($2=="OBJECT"){print $1}}' ___raw2-log.lst > ___obj-2.lst
!awk '{if($2=="OBJECT"){print $1}}' ___raw3-log.lst > ___obj-3.lst
!awk '{if($2=="OBJECT"){print $1}}' ___raw4-log.lst > ___obj-4.lst
!awk '{if($2=="OBJECT"){print $1}}' ___raw5-log.lst > ___obj-5.lst
!awk '{if($2=="OBJECT"){print $1}}' ___raw6-log.lst > ___obj-6.lst
!awk '{if($2=="OBJECT"){print $1}}' ___raw7-log.lst > ___obj-7.lst

#
# 2.2: Making "DS" directory to be put dark-subtracted images.  
!mkdir DS

#
# 2.3: Making "ds" object image list.
!awk '{print "DS/ds"substr($1,5)}' ___obj-0.lst > ___dsobj-0.lst 
!awk '{print "DS/ds"substr($1,5)}' ___obj-1.lst > ___dsobj-1.lst 
!awk '{print "DS/ds"substr($1,5)}' ___obj-2.lst > ___dsobj-2.lst 
!awk '{print "DS/ds"substr($1,5)}' ___obj-3.lst > ___dsobj-3.lst 
!awk '{print "DS/ds"substr($1,5)}' ___obj-4.lst > ___dsobj-4.lst 
!awk '{print "DS/ds"substr($1,5)}' ___obj-5.lst > ___dsobj-5.lst 
!awk '{print "DS/ds"substr($1,5)}' ___obj-6.lst > ___dsobj-6.lst 
!awk '{print "DS/ds"substr($1,5)}' ___obj-7.lst > ___dsobj-7.lst 

#
# 2.4: Dark subtraction.
imarith @___obj-0.lst - DARK480-0.fits @___dsobj-0.lst
imarith @___obj-1.lst - DARK480-1.fits @___dsobj-1.lst
imarith @___obj-2.lst - DARK480-2.fits @___dsobj-2.lst
imarith @___obj-3.lst - DARK480-3.fits @___dsobj-3.lst
imarith @___obj-4.lst - DARK480-4.fits @___dsobj-4.lst
imarith @___obj-5.lst - DARK480-5.fits @___dsobj-5.lst
imarith @___obj-6.lst - DARK480-6.fits @___dsobj-6.lst
imarith @___obj-7.lst - DARK480-7.fits @___dsobj-7.lst

!echo "2.4: Dark subtraction were finished."








#
# 2.5: Normalizing  dark-subtracted flat images.
imstat @___dsflat-0.lst fields=midpt format=no > ___dsflat-0-med.dat
imstat @___dsflat-1.lst fields=midpt format=no > ___dsflat-1-med.dat
imstat @___dsflat-2.lst fields=midpt format=no > ___dsflat-2-med.dat
imstat @___dsflat-3.lst fields=midpt format=no > ___dsflat-3-med.dat
imstat @___dsflat-4.lst fields=midpt format=no > ___dsflat-4-med.dat
imstat @___dsflat-5.lst fields=midpt format=no > ___dsflat-5-med.dat
imstat @___dsflat-6.lst fields=midpt format=no > ___dsflat-6-med.dat
imstat @___dsflat-7.lst fields=midpt format=no > ___dsflat-7-med.dat

!mkdir NM

!awk '{print "NM/nm"substr($1,6)}' ___dsflat-0.lst > ___nmflat-0.lst
!awk '{print "NM/nm"substr($1,6)}' ___dsflat-1.lst > ___nmflat-1.lst
!awk '{print "NM/nm"substr($1,6)}' ___dsflat-2.lst > ___nmflat-2.lst
!awk '{print "NM/nm"substr($1,6)}' ___dsflat-3.lst > ___nmflat-3.lst
!awk '{print "NM/nm"substr($1,6)}' ___dsflat-4.lst > ___nmflat-4.lst
!awk '{print "NM/nm"substr($1,6)}' ___dsflat-5.lst > ___nmflat-5.lst
!awk '{print "NM/nm"substr($1,6)}' ___dsflat-6.lst > ___nmflat-6.lst
!awk '{print "NM/nm"substr($1,6)}' ___dsflat-7.lst > ___nmflat-7.lst

#
# 2.6: Normalization.

imarith @___dsflat-0.lst / @___dsflat-0-med.dat @___nmflat-0.lst
imarith @___dsflat-1.lst / @___dsflat-1-med.dat @___nmflat-1.lst
imarith @___dsflat-2.lst / @___dsflat-2-med.dat @___nmflat-2.lst
imarith @___dsflat-3.lst / @___dsflat-3-med.dat @___nmflat-3.lst
imarith @___dsflat-4.lst / @___dsflat-4-med.dat @___nmflat-4.lst
imarith @___dsflat-5.lst / @___dsflat-5-med.dat @___nmflat-5.lst
imarith @___dsflat-6.lst / @___dsflat-6-med.dat @___nmflat-6.lst
imarith @___dsflat-7.lst / @___dsflat-7-med.dat @___nmflat-7.lst

#
# 2.7: Combining normalized flat images

imcombine @___nmflat-0.lst FlatI-0.fits combine=median reject=avsigclip offsets=none 
imcombine @___nmflat-1.lst FlatI-1.fits combine=median reject=avsigclip offsets=none 
imcombine @___nmflat-2.lst FlatI-2.fits combine=median reject=avsigclip offsets=none 
imcombine @___nmflat-3.lst FlatI-3.fits combine=median reject=avsigclip offsets=none 
imcombine @___nmflat-4.lst FlatI-4.fits combine=median reject=avsigclip offsets=none 
imcombine @___nmflat-5.lst FlatI-5.fits combine=median reject=avsigclip offsets=none 
imcombine @___nmflat-6.lst FlatI-6.fits combine=median reject=avsigclip offsets=none 
imcombine @___nmflat-7.lst FlatI-7.fits combine=median reject=avsigclip offsets=none 

!echo "2: Eight flat frames were combined."

#
# 3: Removing temporal files
#
del ___*.lst
\rm -fr NM
imdel @___dsflat-0.lst
imdel @___dsflat-1.lst
imdel @___dsflat-2.lst
imdel @___dsflat-3.lst
imdel @___dsflat-4.lst
imdel @___dsflat-5.lst
imdel @___dsflat-6.lst
imdel @___dsflat-7.lst

!echo "3: Temporal files were removed."
!echo "Thank you !!"
#
# Shingo Nishiura
#   Post Doctral fellow at the KISO Observatory from 2001 to 2003
#   Assistant Research at Tokyo Gakugei University from 2003
#   e-mail: nishiura@u-gakugei.ac.jp
#
